#include<bits/stdc++.h>
using namespace std;
int arr[2001];
int dp[20001];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int S,n;
    cin>>S>>n;
    for(int i=0;i<n;i++)
    {
        cin>>arr[i];
    }
    for(int k=1;k<=S;k++)
    {
        dp[k]=1e9;
        for(int i=0;i<n;i++)
        {
            if(arr[i]<=k)
            {
                dp[k]=min(dp[k],dp[k-arr[i]]+1);
            }
        }
    }
    cout<<dp[S];
    return 0;
}
